[BACK]Return to fw_install.sh CVS log [TXT][DIR] Up to [local] / openbsd / fw_update

Annotation of openbsd/fw_update/fw_install.sh, Revision 1.45

1.1       afresh1     1: #!/bin/ksh
1.36      afresh1     2: #      $OpenBSD$
1.1       afresh1     3: set -e
                      4:
1.38      afresh1     5: # Copyright (c) 2021 Andrew Hewus Fresh <afresh1@openbsd.org>
                      6: #
                      7: # Permission to use, copy, modify, and distribute this software for any
                      8: # purpose with or without fee is hereby granted, provided that the above
                      9: # copyright notice and this permission notice appear in all copies.
                     10: #
                     11: # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
                     12: # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
                     13: # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
                     14: # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
                     15: # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
                     16: # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
                     17: # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
                     18:
1.24      afresh1    19: # Fake up some things from install.sub that we don't need to actually do
1.22      afresh1    20: prefetcharea_fs_list() {
1.27      afresh1    21:        echo "${DESTDIR}/tmp"
1.22      afresh1    22: }
                     23:
1.8       afresh1    24: # tmpdir, do_as, unpriv, and unpriv2 are from install.sub
1.43      afresh1    25: # modified to use su(1) when not in the installer.
1.44      afresh1    26: # modified to use mktemp(1) when not in the installer.
1.8       afresh1    27:
                     28: # Create a temporary directory based on the supplied directory name prefix.
                     29: tmpdir() {
                     30:        local _i=1 _dir
1.44      afresh1    31:        if [[ -z $1 ]]; then
                     32:                echo No tmpdir >&2
                     33:                exit 1
                     34:        fi
1.8       afresh1    35:
1.44      afresh1    36:        if [[ -e /usr/bin/mktemp ]]; then
1.45    ! afresh1    37:                _dir=$( /usr/bin/mktemp -d $1 )
1.44      afresh1    38:                chown _sndio "$_dir"
                     39:        else
1.45    ! afresh1    40:                until _dir="${1%-+(X)}.$_i.$RANDOM" && mkdir -- "$_dir" 2>/dev/null; do
1.44      afresh1    41:                    ((++_i < 10000)) || return 1
                     42:                done
                     43:        fi
1.8       afresh1    44:        echo "$_dir"
                     45: }
1.6       afresh1    46:
                     47: # Run a command ($2+) as unprivileged user ($1).
                     48: # Take extra care that after "cmd" no "user" processes exist.
                     49: #
                     50: # Optionally:
                     51: #      - create "file" and chown it to "user"
                     52: #      - after "cmd", chown "file" back to root
                     53: #
                     54: # Usage: do_as user [-f file] cmd
                     55: do_as() {
                     56:        (( $# >= 2 )) || return
                     57:
                     58:        local _file _rc _user=$1
                     59:        shift
                     60:
                     61:        if [[ $1 == -f ]]; then
                     62:                _file=$2
                     63:                shift 2
                     64:        fi
                     65:
                     66:        if [[ -n $_file ]]; then
                     67:                >$_file
                     68:                chown "$_user" "$_file"
                     69:        fi
                     70:
1.42      afresh1    71:        if [[ -x /usr/bin/su ]]; then
                     72:                /usr/bin/su -s /bin/ksh "$_user" -c "$*"
                     73:        else
                     74:                doas -u "$_user" "$@"
                     75:        fi
1.6       afresh1    76:        _rc=$?
                     77:
                     78:        while doas -u "$_user" kill -9 -1 2>/dev/null; do
                     79:                echo "Processes still running for user $_user after: $@"
                     80:                sleep 1
                     81:        done
                     82:
                     83:        [[ -n $_file ]] && chown root "$_file"
                     84:
                     85:        return $_rc
                     86: }
                     87:
                     88: unpriv() {
                     89:        do_as _sndio "$@"
                     90: }
                     91:
                     92: unpriv2() {
                     93:        do_as _file "$@"
                     94: }
                     95:
1.33      afresh1    96: VNAME=${VNAME:-$(sysctl -n kern.osrelease)}
1.34      afresh1    97: VERSION=${VERSION:-"${VNAME%.*}${VNAME#*.}"}
1.33      afresh1    98: FWDIR=${FWDIR:-$VNAME}
1.1       afresh1    99:
1.14      afresh1   100: # TODO: We need the firmware for the system we just installed
                    101: #       not the one we booted from.  For example:
                    102: #       * booting from a snapshot bsd.rd that thinks it is the 7.0 release
                    103: #         will install the firmware from the 7.0 directory instead of
                    104: #         from the snapshots dir.
                    105: #       If they're using sysupgrade, then the installer kernel will be correct.
                    106: #       If we're doing this in the installer we can check what they picked
                    107: #       for downloading sets and use that value.
                    108: #       Otherwise, the fw_update after first boot will fix it up for us.
                    109:
1.7       afresh1   110: HTTP_FWDIR=$FWDIR
1.30      afresh1   111: set -- sed -n "/^OpenBSD $VNAME\([^ ]*\).*$/s//\1/p" /var/run/dmesg.boot
1.7       afresh1   112: [[ $1 == -!(stable) ]] && HTTP_FWDIR=snapshots
                    113:
                    114: FWURL=http://firmware.openbsd.org/firmware/${HTTP_FWDIR}
                    115: FWPUB_KEY=${DESTDIR}/etc/signify/openbsd-${VERSION}-fw.pub
1.37      afresh1   116: FWPATTERNS="${DESTDIR}/usr/share/misc/firmware_patterns"
1.1       afresh1   117:
1.20      afresh1   118: # TODO: support srclocal installation of firmware somehow
1.35      afresh1   119: fw_install() {
1.24      afresh1   120:        local _src=$1 _tmpfs_list _tmpfs _tmpsrc \
1.27      afresh1   121:                _t=Get _cfile="/tmp/SHA256" _pkgdir=${DESTDIR}/var/db/pkg \
1.25      afresh1   122:                _f _r _remove _i _installed
                    123:        local _srclocal=false _unpriv=unpriv
1.26      afresh1   124:
1.15      afresh1   125:        local _d _drivers=$(
1.11      afresh1   126:                last=''
1.15      afresh1   127:                while read _d _m; do
1.11      afresh1   128:                        grep=grep
1.15      afresh1   129:                        [ "$last" = "$_d" ] && continue
                    130:                        [ "$_m" ] || _m="^$_d[0-9][0-9]* at "
                    131:                        [ "$_m" = "${_m#^}" ] && grep=fgrep
                    132:                        $grep -q "$_m" /var/run/dmesg.boot || continue
                    133:                        echo $_d
                    134:                        last=$_d
1.37      afresh1   135:                done < $FWPATTERNS
1.11      afresh1   136:        )
                    137:
                    138:        if [ -z "$_drivers" ]; then
1.22      afresh1   139:                echo "No devices found which need firmware files to be downloaded."
1.11      afresh1   140:                return
                    141:        fi
1.1       afresh1   142:
1.22      afresh1   143:        ! _tmpfs_list=$(prefetcharea_fs_list) &&
                    144:                echo "Cannot determine prefetch area" >&2 && return
                    145:
                    146:        for _tmpfs in $_tmpfs_list; do
                    147:                # Try to clean up from previous runs, assuming
                    148:                # the _tmpfs selection yields the same mount
                    149:                # point.
                    150:                for _tmpsrc in $_tmpfs/firmware.+([0-9]).+([0-9]); do
                    151:                        [[ -d $_tmpsrc ]] && rm -r $_tmpsrc
                    152:                done
                    153:
                    154:                # Create a download directory for the firmware and
                    155:                # check that the _sndio user can read files from
                    156:                # it. Otherwise cleanup and skip the filesystem.
1.44      afresh1   157:                if _tmpsrc=$(tmpdir "$_tmpfs/firmware-XXXXXXXXX"); then
1.22      afresh1   158:                        (
                    159:                        >$_tmpsrc/t &&
                    160:                        $_unpriv cat $_tmpsrc/t
                    161:                        ) >/dev/null 2>&1 && break ||
                    162:                                rm -r $_tmpsrc
                    163:                fi
                    164:        done
1.1       afresh1   165:
1.11      afresh1   166:        [[ ! -d $_tmpsrc ]] &&
1.22      afresh1   167:                echo "Cannot create prefetch area" >&2 && return 1
1.1       afresh1   168:
1.16      afresh1   169:        # Cleanup from previous runs.
                    170:        rm -f $_cfile $_cfile.sig
                    171:
1.21      afresh1   172:        _t=Get/Verify
1.17      afresh1   173:
1.11      afresh1   174:        ! $_unpriv ftp -D "$_t" -Vmo - "$_src/SHA256.sig" >"$_cfile.sig" &&
1.22      afresh1   175:            echo "Cannot fetch SHA256.sig" >&2 && return 1
1.1       afresh1   176:
1.11      afresh1   177:        # Verify signature file with public keys.
1.24      afresh1   178:        ! $_unpriv -f "$_cfile" \
1.11      afresh1   179:            signify -Vep $FWPUB_KEY -x "$_cfile.sig" -m "$_cfile" &&
1.22      afresh1   180:            echo "Signature check of SHA256.sig failed" >&2 && return 1
1.11      afresh1   181:
1.15      afresh1   182:        for _d in $_drivers; do
1.41      afresh1   183:                _f=$( sed -n "s/.*(\($_d-firmware-.*\.tgz\)).*/\1/p" "$_cfile" | sed '$!d' )
1.19      afresh1   184:                _installed=$(
1.22      afresh1   185:                for fw in "${_pkgdir}/$_d-firmware"*; do
1.19      afresh1   186:                        [ -e "$fw" ] || continue
                    187:                        echo ${fw##*/}
                    188:                done
1.21      afresh1   189:                )
1.15      afresh1   190:
                    191:                for _i in $_installed; do
                    192:                        if [ "$_f" = "$_i.tgz" ]; then
1.24      afresh1   193:                                echo "$_i already installed"
1.11      afresh1   194:                                continue 2
1.1       afresh1   195:                        fi
                    196:                done
                    197:
1.11      afresh1   198:                rm -f /tmp/h /tmp/fail
                    199:
                    200:                # Fetch firmware file and create a checksum by piping through
                    201:                # sha256. Create a flag file in case ftp failed. Firmware
                    202:                # from net is written to the prefetch area.
                    203:                ( $_unpriv ftp -D "$_t" -Vmo - "$_src/$_f" || >/tmp/fail ) |
                    204:                ( $_srclocal && unpriv2 sha256 -b >/tmp/h ||
                    205:                    unpriv2 -f /tmp/h sha256 -bph /tmp/h >"$_tmpsrc/$_f" )
                    206:
                    207:                # Handle failed transfer.
                    208:                if [[ -f /tmp/fail ]]; then
                    209:                        rm -f "$_tmpsrc/$_f"
1.22      afresh1   210:                        echo "Fetching of $_f failed!" >&2
                    211:                        continue
1.11      afresh1   212:                fi
                    213:
                    214:                # Verify firmware by comparing its checksum with SHA256.
1.22      afresh1   215:                if ! fgrep -qx "SHA256 ($_f) = $(</tmp/h)" "$_cfile"; then
1.11      afresh1   216:                        [[ -d "$_tmpsrc" ]] && rm -rf "$_tmpsrc"
1.22      afresh1   217:                        echo "Checksum test for $_f failed." >&2
                    218:                        continue
1.11      afresh1   219:                fi
                    220:
                    221:                # TODO: Check hash for files before deleting
1.22      afresh1   222:                if [ "$_installed" ] && [ -e "${_pkgdir}/$_installed/+CONTENTS" ]; then
1.18      afresh1   223:                        echo "Uninstalling $_installed"
1.22      afresh1   224:                        cwd=${_pkgdir}/$_installed
1.11      afresh1   225:
                    226:                        set -A _remove -- "${cwd}/+CONTENTS" "${cwd}"
                    227:
                    228:                        while read c g; do
                    229:                                case $c in
1.27      afresh1   230:                                @cwd) cwd="${DESTDIR}/$g"
1.11      afresh1   231:                                  ;;
                    232:                                @*) continue
                    233:                                  ;;
                    234:                                *)  set -A _remove -- "$cwd/$c" "${_remove[@]}"
                    235:                                  ;;
                    236:                                esac
1.22      afresh1   237:                        done < "${_pkgdir}/$_installed/+CONTENTS"
1.11      afresh1   238:
1.21      afresh1   239:                        # We specifically rm -f here because not removing files/dirs
                    240:                        # is probably not worth failing over.
1.11      afresh1   241:                        for _r in "${_remove[@]}" ; do
                    242:                                if [ -d "$_r" ]; then
                    243:                                        # Try hard not to actually remove recursively
                    244:                                        # without rmdir on the install media.
                    245:                                        [ "$_r/*" = $( echo "$_r"/* ) ] && rm -rf "$_r"
                    246:                                else
                    247:                                        rm -f "$_r"
                    248:                                fi
                    249:                        done
                    250:                fi
                    251:
1.21      afresh1   252:                # TODO: Should we mark these so real fw_update can -Drepair?
1.25      afresh1   253:                ftp -D "Install" -Vmo- "file:$_tmpsrc/$_f" |
                    254:                        tar -s ",^\+,${_pkgdir}/${_f%.tgz}/+," \
1.28      afresh1   255:                        -s ",^firmware,${DESTDIR}/etc/firmware," \
1.25      afresh1   256:                        -C / -zxphf - "+*" "firmware/*"
1.23      afresh1   257:
1.22      afresh1   258:                ed -s "${_pkgdir}/${_f%.tgz}/+CONTENTS" <<EOL
1.1       afresh1   259: /^@comment pkgpath/ -1a
                    260: @option manual-installation
                    261: @option firmware
                    262: @comment install-script
                    263: .
                    264: w
                    265: EOL
1.11      afresh1   266:        done
                    267: }
1.1       afresh1   268:
1.35      afresh1   269: fw_install "$FWURL"

FreeBSD-CVSweb <freebsd-cvsweb@FreeBSD.org>